/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this file,
 * You can obtain one at http://mozilla.org/MPL/2.0/. */

/* Software by P.J.Sloetjes. */

"use strict";

const 
	id = "nosmalltext",
	mo = [],
	pr = {ats: [0, 1], siz: [1, 5], dif: [2, ""]};

const
	fn = ["ar", "x-armn", "x-beng", "x-baltic", "x-central-euro",
		"zh-CN", "zh-HK", "zh-TW", "x-cyrillic", "x-devanagari",
		"x-ethi", "x-geor", "el", "x-gujr", "x-guru", "he", "ja",
		"x-knda", "x-khmr", "ko", "x-mlym", "x-orya", "x-sinh",
		"x-tamil", "x-telu", "th", "x-tibt", "tr", "x-cans", 
		"x-western", "x-unicode", "x-user-def"],
	fo = "chrome://browser/content/preferences/fonts.xul",
	mx = 16, mn = 6,
	sz = [8, 9, 10, 11, 12, 13, 14, 15, 
		16, 17, 18, 20, 22, 24, 36, 48];

function addonInit(p, r) {
	setSizes(1);
}

function addonExit(p, r) {
	setSizes(0);
}

function addonMenu(d, b) {
	var i, m, r, h, s = pref("siz");
	m = gui(d, "menupopup", "menu");
	r = gui(m, "radiogroup");
	for (i = 0; i < sz.length; i++)
		gui(r, "menuitem", i + 1, "",
			{type: "radio", 
			label: sz[i] + "pt",
			checked: i === s,
			closemenu: "none"});
	s = pref("dif");
	h = gui(m, "menu", ud, "",
		{label: "+/-"});
	h = gui(h, "menupopup");
	for (i in fn) {
		r = gui(h, "hbox");
		gui(r, "textbox", fn[i], 
			"min-width:2.5em;",
			{type: "number", 
				size: 2, maxlength: 2,
				min: -mn, max: mx,
				value: difSize(fn[i], s),
				"class": "plain"});
		gui(r, "textbox", "t" + fn[i], 
			"margin-left:.3em;",
			{value: fn[i], size: 35,
			"class": "plain"});
	}
	h = gui(m, "iframe", "f", 
		"display:none;", {src: fo});
	on(1, h, {DOMContentLoaded: getLangs});
	b.appendChild(m);
}

function getLangs(e) {
	const c = e[tg],
		s = el(c, "selectLangs"),
		n = eln(s, "menuitem"), 
		f = c[dv] && c[dv].frameElement,
		d = f && f[od];
	var i = (n && n.length) | 0, j, v;
	while (i--)
		(v = n[i].getAttribute("value")) &&
				(fn.indexOf(v) + 1) &&
				(e = el(d, id + "t" + v)) &&
			e.setAttribute("value",
				n[i].getAttribute("label"));
	f && f.parentNode.removeChild(f);
}

function addonWake(d, e, b) {
	on(e, b || el(d, id), {
		click: clickButton,
		change: changeDif});
	e && updateButton(d);
}

function difSize(i, s) {
	let n = s.indexOf("|" + i);
	return n < 0 ? 0 :
		parseInt(s.substr(
			n + i.length + 1, 2));
}

function parseDif(s, i, j) {
	j = parseInt(s.substr(j + i.length + 1, 2));
	return j >= -mn && j <= mx ? j : 0;
}

function updateButton(d, b) {
	(b = b || el(d, id)) &&
		b.style.setProperty(
			"-moz-image-region", 
			icon(+pref("ats")),
			"important");
}

function clickButton(e) {
	if (e.button)
		return;
	if (!fromButton(e))
		return clickMenu(e);
	pref("ats", !pref("ats"));
	setSizes(1);
	browsers(updateButton);
}

function clickMenu(e) {
	let a = e[tg], i = a.id;
	i = i && parseInt(
		i.substring(11));
	if (!(i > 0))
		return;
	pref("siz", i - 1);
	setSizes(1);
	browsers(updateSize, a[od]);
}

function updateSize(d) {
	d = d[tg] ? d[tg][od] : d;
	var i = 0, s = +pref("siz"), e, j;
	while ((e = el(d, id + (++i))))
		e.setAttribute("checked", i - 1 === s);
}

function changeDif(e) {
	let a = e[tg], i = a.id;
	i = i && i.substring(11);
	if (fn.indexOf(i) < 0)
		return;
	let s = pref("dif"),
		j = s.indexOf("|" + i),
		v = el(a[od], id + i).valueNumber;
	s = j < 0 ? s + "|" + i + v :
		s.replace("|" + i + parseDif(s, i, j),
				v === 0 ? "" : "|" + i + v);
	pref("dif", s);
	browsers(updateDif, a[od], i, v);
	setSizes(1);
}

function updateDif(d, o, i, v) {
	if (d = el(d, id + i))
		d.valueNumber = v;
}

function setSizes(a) {
	var i, j, s = pref("dif"),
		p = Sv.prefs.getBranch(
			"font.minimum-size.");
	a = a && pref("ats") ? 
		sz[pref("siz")] : 0;
	if (p && a >= 0)
		for (i in fn) {
			j = s.indexOf("|" + fn[i]);
			j = j < 0 ? 0 : parseDif(s, fn[i], j);
			p.setIntPref(fn[i], a ? a + j : 0);
		}
}
